/**
 * <p>Класс для тестирования трассировки стека</p>
 * */
public class StackTraceTest {
    /**
     * <p>Функция для нахождения факториала. Перед расчетом факториала выводится стек-трайс функции</p>
     * @param n Файкториал чего мы считаем
     * @return Значение факториала
     * */
    public static int factorial(int n) {
        System.out.println("factorial(" + n + "):");

        Throwable throwable = new Throwable();
        StackTraceElement[] stackTraceElements = throwable.getStackTrace();

        for (StackTraceElement stackTraceElement : stackTraceElements) {
            System.out.println(stackTraceElement);
        }

        int ans = 1;
        if (n > 1) {
            ans = n * factorial(n - 1);
        }

        System.out.println("return " + ans);

        return ans;
    }

    public static void main(String[] args) {
        factorial(3);
    }
}
